Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/Policy.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/Policy.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/Policy.cs	(revision 2065)
@@ -0,0 +1,31 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class Policy {
+    private string _name;
+    public string Name { get { return _name; } set { this._name = value; } }
+
+    private IDictionary<Permission, PermissionContext> _permissions = new Dictionary<Permission, PermissionContext>();
+    public IDictionary<Permission, PermissionContext> Permissions { get { return this._permissions; } set { this._permissions = value; } }
+
+    public Policy(string name) {
+      this._name = name;
+    }
+
+    public void AddPermission(Permission permission, PermissionContext ctx) {
+      this._permissions.Add(permission, ctx);
+    }
+
+    public Permission GetPermissionByContext(string context) {
+      foreach (KeyValuePair<Permission, PermissionContext> item in _permissions) {
+        if (item.Value.Elevation == context)
+          return item.Key;
+      }
+      return null;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PolicyCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PolicyCollection.cs	(revision 2065)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/Authorization/PolicyCollection.cs	(revision 2065)
@@ -0,0 +1,30 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class PolicyCollection : IEnumerable<Policy> {
+    private IList<Policy> _policies = new List<Policy>();
+
+    public IList<Policy> Policies { get { return this._policies; } }
+
+    public Policy this[string name] {
+      get {
+        foreach (Policy item in _policies) {
+          if (item.Name == name)
+            return item;
+        }
+        return null;
+      }
+    }
+
+    public IEnumerator<Policy> GetEnumerator() {
+      return this._policies.GetEnumerator();
+    }
+
+    System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
+      return this._policies.GetEnumerator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 2065)
@@ -85,4 +85,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Authorization\HivePermissions.cs" />
+    <Compile Include="Authorization\PermissionCollection.cs" />
+    <Compile Include="Authorization\PermissionContext.cs" />
+    <Compile Include="Authorization\PermissionException.cs" />
+    <Compile Include="Authorization\Policy.cs" />
+    <Compile Include="Authorization\PolicyCollection.cs" />
     <Compile Include="ClientCommunicator.cs" />
     <Compile Include="ClientFacade.cs" />
@@ -90,5 +96,5 @@
     <Compile Include="DbTestApp.cs" />
     <Compile Include="ExecutionEngineFacade.cs" />
-    <Compile Include="HivePermissionManager.cs" />
+    <Compile Include="Authorization\HivePermissionManager.cs" />
     <Compile Include="HiveServerCorePlugin.cs" />
     <Compile Include="HiveServerMessages.Designer.cs" />
@@ -98,5 +104,4 @@
     <Compile Include="JobManager.cs" />
     <Compile Include="LifecycleManager.cs" />
-    <Compile Include="PermissiveSecurityConstants.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="ServerConsoleFacade.cs" />
@@ -112,4 +117,7 @@
     <None Include="app.config" />
     <None Include="HeuristicLab.snk" />
+    <EmbeddedResource Include="Authorization\HivePermissionSet.xsd">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </EmbeddedResource>
     <None Include="Properties\AssemblyInfo.frame" />
     <None Include="Properties\Settings.settings">
@@ -148,4 +156,12 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Authorization\HivePermissionSet.xml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </EmbeddedResource>
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="Authorization\HivePermissionPolicy.xml" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IHivePermissionManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IHivePermissionManager.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IHivePermissionManager.cs	(revision 2065)
@@ -2,4 +2,12 @@
 namespace HeuristicLab.Hive.Server.Core.InternalInterfaces {
   public interface IHivePermissionManager {
+    /// <summary>
+    /// Checks user permission against predefined policy in database.
+    /// </summary>
+    /// <param name="permission">the name of policy defined in xml-file</param>
+    /// <param name="sessionID">the users current session ID</param>
+    /// <param name="entityID"></param>
+    /// <exception cref="PermissionException">thrown when access denied</exception>
+    void Authorize(string policyName, Guid sessionID, Guid entityID);
     bool CheckPermission(Guid sessionID, Guid actionID, Guid entityId);
     Guid Login(string username, string password);
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 2065)
@@ -29,4 +29,6 @@
 using HeuristicLab.Security.Contracts.Interfaces;
 using HeuristicLab.Hive.Server.Core.InternalInterfaces;
+using System.ServiceModel;
+
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -45,5 +47,4 @@
       Response resp = new Response();
      
-      /*
       sessionID = secMan.Login(username, password);
       if (sessionID == Guid.Empty) {
@@ -55,8 +56,4 @@
           ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
       }
-      */ 
-      sessionID = Guid.Empty;
-      resp.Success = true;
-      resp.StatusMessage = ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
       return resp;
     }
@@ -64,154 +61,104 @@
 
     public ResponseList<ClientInfo> GetAllClients() {
-      if (HasPermission(PermissiveSecurityAction.List_AllClients))
-        return clientManager.GetAllClients();
-      else
-        throw new PermissionException();
+      secMan.Authorize("AccessClients", sessionID, Guid.Empty);
+      return clientManager.GetAllClients();
     }
 
     public ResponseList<ClientGroup> GetAllClientGroups() {
-      if (HasPermission(PermissiveSecurityAction.List_AllClientGroups))
-        return clientManager.GetAllClientGroups();
-      else
-        throw new PermissionException();
+      secMan.Authorize("AccessClientGroup", sessionID, Guid.Empty);
+      return clientManager.GetAllClientGroups();
     }
 
     public ResponseList<UpTimeStatistics> GetAllUpTimeStatistics() {
-      if (HasPermission(PermissiveSecurityAction.Show_Statistics))
-        return clientManager.GetAllUpTimeStatistics();
-      else
-        throw new PermissionException();
+      secMan.Authorize("AccessStatistics", sessionID, Guid.Empty);
+      return clientManager.GetAllUpTimeStatistics();
     }
 
     public ResponseObject<ClientGroup> AddClientGroup(ClientGroup clientGroup) {
-      if (HasPermission(PermissiveSecurityAction.Add_ClientGroup))
-        return clientManager.AddClientGroup(clientGroup);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AddClientGroup", sessionID, Guid.Empty);
+      return clientManager.AddClientGroup(clientGroup);
     }
 
     public Response AddResourceToGroup(Guid clientGroupId, Resource resource) {
-      if (HasPermission(PermissiveSecurityAction.Add_Resource))
-        return clientManager.AddResourceToGroup(clientGroupId, resource);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AddResource", sessionID, Guid.Empty);                
+      return clientManager.AddResourceToGroup(clientGroupId, resource);
     }
 
     public Response DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
-      if (HasPermission(PermissiveSecurityAction.Delete_Resource))
         return clientManager.DeleteResourceFromGroup(clientGroupId, resourceId);
-      else
-        throw new PermissionException();
     }
 
-
-    public ResponseList<HeuristicLab.Hive.Contracts.BusinessObjects.Job> GetAllJobs() {
-      if (HasPermission(PermissiveSecurityAction.Get_AllJobs))
-        return jobManager.GetAllJobs();
-      else
-        throw new PermissionException();
+    public ResponseList<Job> GetAllJobs() {
+      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+      return jobManager.GetAllJobs();
     }
 
-    public ResponseObject<HeuristicLab.Hive.Contracts.BusinessObjects.Job> GetJobById(Guid jobId) {
+    public ResponseObject<Job> GetJobById(Guid jobId) {
+      secMan.Authorize("AccessJobs", sessionID, jobId);
       return jobManager.GetJobById(jobId);
     }
 
     public ResponseObject<Job> AddNewJob(Job job) {
-      if (HasPermission(PermissiveSecurityAction.Add_Job))
-        return jobManager.AddNewJob(job);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AddJob", sessionID, job.Id);
+      return jobManager.AddNewJob(job);
     }
 
     public ResponseObject<JobResult> GetLastJobResultOf(Guid jobId, bool requested) {
-      if (HasPermission(PermissiveSecurityAction.Get_LastJobResult))
-        return jobManager.GetLastJobResultOf(jobId, requested);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AccessJobResults", sessionID, jobId);
+      return jobManager.GetLastJobResultOf(jobId, requested);
     }
 
     public ResponseList<JobResult> GetAllJobResults(Guid jobId) {
-      if (HasPermission(PermissiveSecurityAction.Get_AllJobResults))
-        return jobManager.GetAllJobResults(jobId);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AccessJobResults", sessionID, jobId);  
+      return jobManager.GetAllJobResults(jobId);
     }
 
     public Response RemoveJob(Guid jobId) {
-      if (HasPermission(PermissiveSecurityAction.Remove_Job))
-        return jobManager.RemoveJob(jobId);
-      else
-        throw new PermissionException();
+      secMan.Authorize("RemoveJob", sessionID, jobId);
+      return jobManager.RemoveJob(jobId);
     }
 
     public Response RequestSnapshot(Guid jobId) {
-      if (HasPermission(PermissiveSecurityAction.Request_Snapshot))
-        return jobManager.RequestSnapshot(jobId);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AccessJobResults", sessionID, jobId);  
+      return jobManager.RequestSnapshot(jobId);
     }
 
     public Response AbortJob(Guid jobId) {
-      if (HasPermission(PermissiveSecurityAction.Abort_Job))
-        return jobManager.AbortJob(jobId);
-      else
-        throw new PermissionException();
+      secMan.Authorize("AbortJob", sessionID, Guid.Empty);
+      return jobManager.AbortJob(jobId);
     }
 
     public ResponseObject<List<ClientGroup>> GetAllGroupsOfResource(Guid resourceId) {
-      if (HasPermission(PermissiveSecurityAction.Get_AllGroupsOfResource))
-        return clientManager.GetAllGroupsOfResource(resourceId);
-      else
-        throw new PermissionException();      
+      secMan.Authorize("AccessUserGroup", sessionID, Guid.Empty);
+      return clientManager.GetAllGroupsOfResource(resourceId);
     }
 
     public Response DeleteClientGroup(Guid clientGroupId) {
+      secMan.Authorize("DeleteClientGroup", sessionID, Guid.Empty);
       return clientManager.DeleteClientGroup(clientGroupId);
     }
 
-  /*
-    private bool HasPermission(Guid action) {
-      return (sessionID == Guid.Empty) ? false : secMan.CheckPermission(sessionID, action, Guid.Empty);
-    }
-
-    private bool HasPermission(Guid action, Guid entityId) {
-      return (sessionID == Guid.Empty) ? false : secMan.CheckPermission(sessionID, action, entityId);
-    }
-   */
-
-    [Obsolete("Only for testing!")]
-    private bool HasPermission(Guid g) { return true; }
-    [Obsolete("Only for testing!")]
-    private bool HasPermission(Guid g, Guid f) { return true; }
-
-    public class PermissionException : Exception {
-      public PermissionException()
-        : base("Current user has insufficent rights for this action!") {
-      }
-
-      public PermissionException(string msg)
-        : base(msg) {
-      }
-
-
-    }
-
     public ResponseList<Project> GetAllProjects() {
+      secMan.Authorize("AccessProjects", sessionID, Guid.Empty);
       return jobManager.GetAllProjects();
     }
 
     public Response CreateProject(Project project) {
+      secMan.Authorize("CreateProjects", sessionID, Guid.Empty);
       return jobManager.CreateProject(project);
     }
 
     public Response ChangeProject(Project project) {
+      secMan.Authorize("ChangeProjects", sessionID, Guid.Empty);
       return jobManager.ChangeProject(project);
     }
 
     public Response DeleteProject(Guid projectId) {
+      secMan.Authorize("DeleteProjects", sessionID, projectId);
       return jobManager.DeleteProject(projectId);
     }
 
     public ResponseList<Job> GetJobsByProject(Guid projectId) {
+      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
       return jobManager.GetJobsByProject(projectId);
     }
Index: trunk/sources/HeuristicLab.Hive.Server/3.2/HeuristicLab.Hive.Server-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server/3.2/HeuristicLab.Hive.Server-3.2.csproj	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server/3.2/HeuristicLab.Hive.Server-3.2.csproj	(revision 2065)
@@ -112,4 +112,5 @@
       <AutoGen>True</AutoGen>
       <DependentUpon>Resources.resx</DependentUpon>
+      <DesignTime>True</DesignTime>
     </Compile>
     <None Include="Properties\AssemblyInfo.frame" />
@@ -139,4 +140,7 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <None Include="Resources\HeuristicLab.ico" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.Hive.Server/3.2/HiveServerApplication.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server/3.2/HiveServerApplication.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server/3.2/HiveServerApplication.cs	(revision 2065)
@@ -30,4 +30,5 @@
 using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Server.Properties;
 
 namespace HeuristicLab.Hive.Server {
@@ -158,9 +159,7 @@
 
         lifecycleManager.Init();
-
         Form mainForm = new MainForm(baseAddrDict);
-
         Application.Run(mainForm);
-
+        
         lifecycleManager.Shutdown();
       }
Index: trunk/sources/HeuristicLab.Hive.Server/3.2/MainForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server/3.2/MainForm.Designer.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server/3.2/MainForm.Designer.cs	(revision 2065)
@@ -29,10 +29,14 @@
         private void InitializeComponent()
         {
+          this.components = new System.ComponentModel.Container();
           this.label1 = new System.Windows.Forms.Label();
-          this.lblAddress1 = new System.Windows.Forms.Label();
-          this.label2 = new System.Windows.Forms.Label();
-          this.lblAddress2 = new System.Windows.Forms.Label();
-          this.label3 = new System.Windows.Forms.Label();
-          this.lblAddress3 = new System.Windows.Forms.Label();
+          this.rtfServices = new System.Windows.Forms.RichTextBox();
+          this.ni = new System.Windows.Forms.NotifyIcon(this.components);
+          this.ctxNotifyMenu = new System.Windows.Forms.ContextMenuStrip(this.components);
+          this.tsShowInfo = new System.Windows.Forms.ToolStripMenuItem();
+          this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
+          this.tsExit = new System.Windows.Forms.ToolStripMenuItem();
+          this.btnClose = new System.Windows.Forms.Button();
+          this.ctxNotifyMenu.SuspendLayout();
           this.SuspendLayout();
           // 
@@ -40,68 +44,81 @@
           // 
           this.label1.AutoSize = true;
-          this.label1.Location = new System.Drawing.Point(18, 18);
+          this.label1.Location = new System.Drawing.Point(12, 9);
           this.label1.Name = "label1";
-          this.label1.Size = new System.Drawing.Size(183, 13);
+          this.label1.Size = new System.Drawing.Size(97, 13);
           this.label1.TabIndex = 0;
-          this.label1.Text = "Hive Server Client Facade running @";
+          this.label1.Text = "Available Services:";
           // 
-          // lblAddress1
+          // rtfServices
           // 
-          this.lblAddress1.AutoSize = true;
-          this.lblAddress1.Location = new System.Drawing.Point(18, 43);
-          this.lblAddress1.Name = "lblAddress1";
-          this.lblAddress1.Size = new System.Drawing.Size(44, 13);
-          this.lblAddress1.TabIndex = 1;
-          this.lblAddress1.Text = "address";
+          this.rtfServices.Location = new System.Drawing.Point(12, 25);
+          this.rtfServices.Name = "rtfServices";
+          this.rtfServices.ReadOnly = true;
+          this.rtfServices.Size = new System.Drawing.Size(280, 121);
+          this.rtfServices.TabIndex = 1;
+          this.rtfServices.Text = "";
           // 
-          // label2
+          // ni
           // 
-          this.label2.AutoSize = true;
-          this.label2.Location = new System.Drawing.Point(18, 76);
-          this.label2.Name = "label2";
-          this.label2.Size = new System.Drawing.Size(195, 13);
-          this.label2.TabIndex = 2;
-          this.label2.Text = "Hive Server Console Facade running @";
+          this.ni.ContextMenuStrip = this.ctxNotifyMenu;
+          this.ni.Text = "notifyIcon1";
+          this.ni.Visible = true;
           // 
-          // lblAddress2
+          // ctxNotifyMenu
           // 
-          this.lblAddress2.AutoSize = true;
-          this.lblAddress2.Location = new System.Drawing.Point(18, 102);
-          this.lblAddress2.Name = "lblAddress2";
-          this.lblAddress2.Size = new System.Drawing.Size(44, 13);
-          this.lblAddress2.TabIndex = 3;
-          this.lblAddress2.Text = "address";
+          this.ctxNotifyMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.tsShowInfo,
+            this.toolStripSeparator1,
+            this.tsExit});
+          this.ctxNotifyMenu.Name = "ctxNotifyMenu";
+          this.ctxNotifyMenu.Size = new System.Drawing.Size(106, 54);
           // 
-          // label3
+          // tsShowInfo
           // 
-          this.label3.AutoSize = true;
-          this.label3.Location = new System.Drawing.Point(18, 131);
-          this.label3.Name = "label3";
-          this.label3.Size = new System.Drawing.Size(206, 13);
-          this.label3.TabIndex = 4;
-          this.label3.Text = "Hive Execution Engine Facade running @";
+          this.tsShowInfo.Name = "tsShowInfo";
+          this.tsShowInfo.Size = new System.Drawing.Size(105, 22);
+          this.tsShowInfo.Text = "&Info";
+          this.tsShowInfo.Click += new System.EventHandler(this.ShowInfo);
           // 
-          // lblAddress3
+          // toolStripSeparator1
           // 
-          this.lblAddress3.AutoSize = true;
-          this.lblAddress3.Location = new System.Drawing.Point(18, 159);
-          this.lblAddress3.Name = "lblAddress3";
-          this.lblAddress3.Size = new System.Drawing.Size(44, 13);
-          this.lblAddress3.TabIndex = 5;
-          this.lblAddress3.Text = "address";
+          this.toolStripSeparator1.Name = "toolStripSeparator1";
+          this.toolStripSeparator1.Size = new System.Drawing.Size(102, 6);
+          // 
+          // tsExit
+          // 
+          this.tsExit.Name = "tsExit";
+          this.tsExit.Size = new System.Drawing.Size(105, 22);
+          this.tsExit.Text = "E&xit";
+          this.tsExit.Click += new System.EventHandler(this.CloseApp);
+          // 
+          // btnClose
+          // 
+          this.btnClose.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+          this.btnClose.Location = new System.Drawing.Point(279, 1);
+          this.btnClose.Name = "btnClose";
+          this.btnClose.Size = new System.Drawing.Size(22, 21);
+          this.btnClose.TabIndex = 2;
+          this.btnClose.Text = "X";
+          this.btnClose.UseVisualStyleBackColor = true;
+          this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
           // 
           // MainForm
           // 
+          this.AcceptButton = this.btnClose;
           this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
           this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-          this.ClientSize = new System.Drawing.Size(304, 181);
-          this.Controls.Add(this.lblAddress3);
-          this.Controls.Add(this.label3);
-          this.Controls.Add(this.lblAddress2);
-          this.Controls.Add(this.label2);
-          this.Controls.Add(this.lblAddress1);
+          this.CancelButton = this.btnClose;
+          this.ClientSize = new System.Drawing.Size(304, 166);
+          this.ControlBox = false;
+          this.Controls.Add(this.btnClose);
+          this.Controls.Add(this.rtfServices);
           this.Controls.Add(this.label1);
+          this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
           this.Name = "MainForm";
+          this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
           this.Text = "Hive Server";
+          this.TopMost = true;
+          this.ctxNotifyMenu.ResumeLayout(false);
           this.ResumeLayout(false);
           this.PerformLayout();
@@ -112,9 +129,11 @@
 
         private System.Windows.Forms.Label label1;
-        private System.Windows.Forms.Label lblAddress1;
-        private System.Windows.Forms.Label label2;
-        private System.Windows.Forms.Label lblAddress2;
-        private System.Windows.Forms.Label label3;
-        private System.Windows.Forms.Label lblAddress3;
+        private System.Windows.Forms.RichTextBox rtfServices;
+        private System.Windows.Forms.NotifyIcon ni;
+        private System.Windows.Forms.ContextMenuStrip ctxNotifyMenu;
+        private System.Windows.Forms.ToolStripMenuItem tsShowInfo;
+        private System.Windows.Forms.ToolStripSeparator toolStripSeparator1;
+        private System.Windows.Forms.ToolStripMenuItem tsExit;
+        private System.Windows.Forms.Button btnClose;
     }
 }
Index: trunk/sources/HeuristicLab.Hive.Server/3.2/MainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server/3.2/MainForm.cs	(revision 2064)
+++ trunk/sources/HeuristicLab.Hive.Server/3.2/MainForm.cs	(revision 2065)
@@ -7,4 +7,5 @@
 using System.Text;
 using System.Windows.Forms;
+using HeuristicLab.Hive.Server.Properties;
 
 namespace HeuristicLab.Hive.Server
@@ -13,14 +14,38 @@
         public MainForm(Dictionary<string, Uri> addresses) {
           InitializeComponent();
+          this.Visible = false;
+
           Uri uri;
+          StringBuilder servicesTxt = new StringBuilder();
           addresses.TryGetValue(HiveServerApplication.STR_ClientCommunicator, out uri);
-          if(uri!=null)
-            this.lblAddress1.Text = uri.ToString();
+          if (uri != null)
+            servicesTxt.AppendLine(String.Format("Server Client: {0}", uri));
           addresses.TryGetValue(HiveServerApplication.STR_ServerConsoleFacade, out uri);
           if (uri != null)
-            this.lblAddress2.Text = uri.ToString();
+            servicesTxt.AppendLine(String.Format("Server Console: {0}", uri));
           addresses.TryGetValue(HiveServerApplication.STR_ExecutionEngineFacade, out uri);
           if (uri != null)
-            this.lblAddress3.Text = uri.ToString();
+            servicesTxt.AppendLine(String.Format("Execution Engine: {0}", uri));
+
+          rtfServices.AppendText(servicesTxt.ToString());
+
+          ni.Icon = Resources.HeuristicLab;
+          ni.BalloonTipTitle = "HL Hive Server Services";
+          ni.BalloonTipText = servicesTxt.ToString();
+          ni.BalloonTipIcon = ToolTipIcon.Info;
+          ni.Text = "HL Hive Server Services";
+          ni.ShowBalloonTip(10000);
+        }
+
+        private void CloseApp(object sender, EventArgs e) {
+          Dispose();
+        }
+
+        private void ShowInfo(object sender, EventArgs e) {
+          this.Visible = true;
+        }
+
+        private void btnClose_Click(object sender, EventArgs e) {
+          this.Visible = false;
         }
 
